Attribute VB_Name = "Globals"
Option Explicit
'************************************************************************
' HISTORY
' 05/06/2002 - Added defines for Language Monitor use
' 10/10/2002 - Added references for printer driver bypass functions
' 01/03/2003 - Added paGetLMGetProgress
' 11/23/2017 - Added paLMGetPrinterOKStatus2 and paLMRFIDPrinter
' 09/21/2018 - Added paGetDLLVersion
' 10/16/2018 - Added paLMPtrGetStatus
'              Added paLMPtrRFIDPrinter
'              Added paLMPtrIsPipe
'************************************************************************
'The executable and source code (collectively the SOFTWARE) are
'provided "AS IS" without any warranty of any kind.
'Neither Practical Automation Inc. nor its suppliers make any
'warranty of any kind as to the accuracy, suitability, or completness
'of the materials provided and any results obtained from using them.
'Neither Practical Automation Inc. nor its suppliers shall be
'responsible for any claims attributable to errors, omissions, or
'other inaccuracies in the SOFTWARE.
'
'In no event shall Practical Automation Inc., its' directors, officers,
'employees, suppliers, or agents (collectively the LICENSOR) be liable
'to you for any consequential, incidental, or indirect damages
'(including damages for loss of business profits, business interruption,
'loss of business information, and the like) arising out of the use or
'inability to use the SOFTWARE even if LICENSOR has been advised of the
'possibility of such damages.
'************************************************************************
'************************************************************************

Public psdCurrent As PAGESETUPDLG
Public usPrinterName As String * 128
Public usPrinterPort As String * 128
Public usPrinterDriver As String * 128
Public cName&, cPort&, cDriver&

Public uOsv As OSVERSIONINFO
Public PrinterFormsLength As Integer
Public gSpecFileName As String
Public gPrinterType As Integer

'************************************************************************
'************************************************************************


Public Const PRINTER_ACCESS_ADMINISTER = &H4
Public Const PRINTER_ACCESS_USE = &H8

Public Const PSD_MINMARGINS = &H1 '  use caller's
Public Const PSD_MARGINS = &H2 '  use caller's
Public Const PSD_INTHOUSANDTHSOFINCHES = &H4 '  2nd of 4 possible
Public Const PSD_INHUNDREDTHSOFMILLIMETERS = &H8 '  3rd of 4 possible
Public Const PSD_DISABLEMARGINS = &H10
Public Const PSD_DISABLEPRINTER = &H20
Public Const PSD_NOWARNING = &H80 '  must be same as PD_*
Public Const PSD_DISABLEORIENTATION = &H100
Public Const PSD_RETURNDEFAULT = &H400 '  must be same as PD_*
Public Const PSD_DISABLEPAPER = &H200
Public Const PSD_SHOWHELP = &H800 '  must be same as PD_*
Public Const PSD_ENABLEPAGESETUPHOOK = &H2000 '  must be same as PD_*
Public Const PSD_ENABLEPAGESETUPTEMPLATE = &H8000& '  must be same as PD_*
Public Const PSD_ENABLEPAGESETUPTEMPLATEHANDLE = &H20000 '  must be same as PD_*
Public Const PSD_ENABLEPAGEPAINTHOOK = &H40000
Public Const PSD_DISABLEPAGEPAINTING = &H80000

' Public constants
' File open constants
Global Const GENERIC_WRITE = &H40000000
Global Const GENERIC_READ = &H80000000
Global Const FILE_ATTRIBUTE_NORMAL = &H80
Global Const CREATE_ALWAYS = 2
Global Const OPEN_ALWAYS = 4
Global Const INVALID_HANDLE_VALUE = -1

Public Const SRCCOPY = &HCC0020
Public Const SRCPAINT = &HEE0086
Public Const SRCAND = &H8800C6
Public Const SRCINVERT = &H660046
Public Const SRCERASE = &H440328
Public Const NOTSRCCOPY = &H330008
Public Const NOTSRCERASE = &H1100A6
Public Const MERGECOPY = &HC000CA
Public Const MERGEPAINT = &HBB0226
Public Const PATCOPY = &HF00021
Public Const PATPAINT = &HFB0A09
Public Const PATINVERT = &H5A0049
Public Const DSTINVERT = &H550009
Public Const BLACKNESS = &H42&
Public Const WHITENESS = &HFF0062
Public Const BLACKONWHITE = 1
Public Const WHITEONBLACK = 2
Public Const COLORONCOLOR = 3
Public Const DM_ORIENTATION = &H1&
Public Const DM_PAPERSIZE = &H2&
Public Const DM_PAPERLENGTH = &H4&
Public Const DM_PAPERWIDTH = &H8&
Public Const DM_SCALE = &H10&
Public Const DM_COPIES = &H100&
Public Const DM_DEFAULTSOURCE = &H200&
Public Const DM_PRINTQUALITY = &H400&
Public Const DM_COLOR = &H800&
Public Const DM_DUPLEX = &H1000&
Public Const DM_YRESOLUTION = &H2000&
Public Const DM_TTOPTION = &H4000&
Public Const DMORIENT_PORTRAIT = 1
Public Const DMORIENT_LANDSCAPE = 2
Public Const DMPAPER_LETTER = 1
Public Const DMPAPER_LETTERSMALL = 2
Public Const DMPAPER_TABLOID = 3
Public Const DMPAPER_LEDGER = 4
Public Const DMPAPER_LEGAL = 5
Public Const DMPAPER_STATEMENT = 6
Public Const DMPAPER_EXECUTIVE = 7
Public Const DMPAPER_A3 = 8
Public Const DMPAPER_A4 = 9
Public Const DMPAPER_A4SMALL = 10
Public Const DMPAPER_A5 = 11
Public Const DMPAPER_B4 = 12
Public Const DMPAPER_B5 = 13
Public Const DMPAPER_FOLIO = 14
Public Const DMPAPER_QUARTO = 15
Public Const DMPAPER_10X14 = 16
Public Const DMPAPER_11X17 = 17
Public Const DMPAPER_NOTE = 18
Public Const DMPAPER_ENV_9 = 19
Public Const DMPAPER_ENV_10 = 20
Public Const DMPAPER_ENV_11 = 21
Public Const DMPAPER_ENV_12 = 22
Public Const DMPAPER_ENV_14 = 23
Public Const DMPAPER_CSHEET = 24
Public Const DMPAPER_DSHEET = 25
Public Const DMPAPER_ESHEET = 26
Public Const DMPAPER_ENV_DL = 27
Public Const DMPAPER_ENV_C5 = 28
Public Const DMPAPER_ENV_C3 = 29
Public Const DMPAPER_ENV_C4 = 30
Public Const DMPAPER_ENV_C6 = 31
Public Const DMPAPER_ENV_C65 = 32
Public Const DMPAPER_ENV_B4 = 33
Public Const DMPAPER_ENV_B5 = 34
Public Const DMPAPER_ENV_B6 = 35
Public Const DMPAPER_ENV_ITALY = 36
Public Const DMPAPER_ENV_MONARCH = 37
Public Const DMPAPER_ENV_PERSONAL = 38
Public Const DMPAPER_FANFOLD_US = 39
Public Const DMPAPER_FANFOLD_STD_GERMAN = 40
Public Const DMPAPER_FANFOLD_LGL_GERMAN = 41
Public Const DMPAPER_USER = 256
Public Const DMBIN_UPPER = 1
Public Const DMBIN_ONLYONE = 1
Public Const DMBIN_LOWER = 2
Public Const DMBIN_MIDDLE = 3
Public Const DMBIN_MANUAL = 4
Public Const DMBIN_ENVELOPE = 5
Public Const DMBIN_ENVMANUAL = 6
Public Const DMBIN_AUTO = 7
Public Const DMBIN_TRACTOR = 8
Public Const DMBIN_SMALLFMT = 9
Public Const DMBIN_LARGEFMT = 10
Public Const DMBIN_LARGECAPACITY = 11
Public Const DMBIN_CASSETTE = 14
Public Const DMBIN_USER = 256
Public Const DMRES_DRAFT = -1
Public Const DMRES_LOW = -2
Public Const DMRES_MEDIUM = -3
Public Const DMRES_HIGH = -4
Public Const DMCOLOR_MONOCHROME = 1
Public Const DMCOLOR_COLOR = 2
Public Const DMDUP_SIMPLEX = 1
Public Const DMDUP_VERTICAL = 2
Public Const DMDUP_HORIZONTAL = 3
Public Const DMTT_BITMAP = 1
Public Const DMTT_DOWNLOAD = 2
Public Const DMTT_SUBDEV = 3
Public Const DM_UPDATE = 1
Public Const DM_COPY = 2
Public Const DM_PROMPT = 4
Public Const DM_MODIFY = 8
Public Const DM_IN_BUFFER = 8
Public Const DM_IN_PROMPT = 4
Public Const DM_OUT_BUFFER = 2
Public Const DM_OUT_DEFAULT = 1
Public Const DC_FIELDS = 1
Public Const DC_PAPERS = 2
Public Const DC_PAPERSIZE = 3
Public Const DC_MINEXTENT = 4
Public Const DC_MAXEXTENT = 5
Public Const DC_BINS = 6
Public Const DC_DUPLEX = 7
Public Const DC_SIZE = 8
Public Const DC_EXTRA = 9
Public Const DC_VERSION = 10
Public Const DC_DRIVER = 11
Public Const DC_BINNAMES = 12
Public Const DC_ENUMRESOLUTIONS = 13
Public Const DC_FILEDEPENDENCIES = 14
Public Const DC_TRUETYPE = 15
Public Const DC_PAPERNAMES = 16
Public Const DC_ORIENTATION = 17
Public Const DC_COPIES = 18
Public Const DCTT_BITMAP = &H1&
Public Const DCTT_DOWNLOAD = &H2&
Public Const DCTT_SUBDEV = &H4&
Public Const SP_NOTREPORTED = &H4000
Public Const SP_ERROR = (-1)
Public Const SP_APPABORT = (-2)
Public Const SP_USERABORT = (-3)
Public Const SP_OUTOFDISK = (-4)
Public Const SP_OUTOFMEMORY = (-5)
Public Const PR_JOBSTATUS = &H0
Public Const DRIVERVERSION = 0
Public Const TECHNOLOGY = 2
Public Const HORZSIZE = 4
Public Const VERTSIZE = 6
Public Const HORZRES = 8
Public Const VERTRES = 10
Public Const BITSPIXEL = 12
Public Const PLANES = 14
Public Const NUMBRUSHES = 16
Public Const NUMPENS = 18
Public Const NUMMARKERS = 20
Public Const NUMFONTS = 22
Public Const NUMCOLORS = 24
Public Const PDEVICESIZE = 26
Public Const CURVECAPS = 28
Public Const LINECAPS = 30
Public Const POLYGONALCAPS = 32
Public Const TEXTCAPS = 34
Public Const CLIPCAPS = 36
Public Const RASTERCAPS = 38
Public Const ASPECTX = 40
Public Const ASPECTY = 42
Public Const ASPECTXY = 44
Public Const LOGPIXELSX = 88
Public Const LOGPIXELSY = 90
Public Const SIZEPALETTE = 104
Public Const NUMRESERVED = 106
Public Const COLORRES = 108
Public Const RC_BITBLT = 1
Public Const RC_BANDING = 2
Public Const RC_SCALING = 4
Public Const RC_BITMAP64 = 8
Public Const RC_GDI20_OUTPUT = &H10
Public Const RC_DI_BITMAP = &H80
Public Const RC_PALETTE = &H100
Public Const RC_DIBTODEV = &H200
Public Const RC_BIGFONT = &H400
Public Const RC_STRETCHBLT = &H800
Public Const RC_FLOODFILL = &H1000
Public Const RC_STRETCHDIB = &H2000
Public Const GMEM_FIXED = &H0
Public Const GMEM_MOVEABLE = &H2
Public Const GMEM_NOCOMPACT = &H10
Public Const GMEM_NODISCARD = &H20
Public Const GMEM_ZEROINIT = &H40
Public Const GMEM_MODIFY = &H80
Public Const GMEM_DISCARDABLE = &H100
Public Const GMEM_NOT_BANKED = &H1000
Public Const GMEM_SHARE = &H2000
Public Const GMEM_DDESHARE = &H2000
Public Const GMEM_NOTIFY = &H4000
Public Const GMEM_LOWER = GMEM_NOT_BANKED
Public Const DIB_RGB_COLORS = 0
Public Const DIB_PAL_COLORS = 1

Public Const VER_PLATFORM_WIN32_NT& = 2
Public Const VER_PLATFORM_WIN32_WINDOWS& = 1


Public Const vbPRORPortrait = 1
Public Const vbPRORLandscape = 2

Public Const TRANSPARENT& = 1
Public Const FW_BOLD& = 700
Public Const FW_NORMAL& = 400
Public Const FW_REGULAR& = FW_NORMAL
Public Const FW_MEDIUM& = 500
Public Const FW_HEAVY& = 900

' RFID Constants
Public Const RFID_READER_NOT_DETERMINED = &H30     ' Reader presence unknown
Public Const RFID_NO_READER = &H31                 ' No reader installed
Public Const RFID_READER_NON_FUNCTIONAL = &H32     ' Reader installed, but not functional
Public Const RFID_NO_STOCK = &H33                  ' Reader present, stock is OOP
Public Const RFID_TAGLESS_STOCK = &H34             ' Non-RFID stock present.
Public Const RFID_STOCK_LOADED = &H35              ' RFID stock present, but not ready
Public Const RFID_TAG_READY = &H36                 ' RFID Tag in position for reading/writing
Public Const RFID_TAG_FAULTY = &H37                ' cannot read a tag which should be there

Public Const RFID_SUCCESS = &H30                    ' Operation complete; command specific data may follow
Public Const RFID_BUSY = &H31                       ' Operation still in process
Public Const RFID_FAILURE = &H32                    ' Operation failed
Public Const RFID_CANCELLING = &H33                 ' A cancel command is in process
Public Const RFID_CANCELLED = &H34                  ' A cancel operation is complete
Public Const RFID_NO_STATUS = &H35                  ' No operation is in process for this query
Public Const RFID_INVALID_COMMAND = &H36            ' Command and/or parameters invalid


Public Type RECT
        left As Long
        top As Long
        right As Long
        bottom As Long
End Type

Type RECTL
        left As Long
        top As Long
        right As Long
        bottom As Long
End Type

Type Size
    cx As Long
    cy As Long
End Type
    

Public Type OSVERSIONINFO ' 148 bytes
        dwOSVersionInfoSize As Long
        dwMajorVersion As Long
        dwMinorVersion As Long
        dwBuildNumber As Long
        dwPlatformId As Long
        szCSDVersion As String * 128
End Type



Type PRINTER_DEFAULTS
        pDataType As String
        pDevMode As Long
        DesiredAccess As Long
End Type

Type BITMAPINFOHEADER '40 bytes
        biSize As Long
        biWidth As Long
        biHeight As Long
        biPlanes As Integer
        biBitCount As Integer
        biCompression As Long
        biSizeImage As Long
        biXPelsPerMeter As Long
        biYPelsPerMeter As Long
        biClrUsed As Long
        biClrImportant As Long
End Type


Public Const LF_FACESIZE& = 32

Public Type LOGFONT
    lfHeight As Long
    lfWidth As Long
    lfEscapement As Long
    lfOrientation As Long
    lfWeight As Long
    lfItalic As Byte
    lfUnderline As Byte
    lfStrikeOut As Byte
    lfCharSet As Byte
    lfOutPrecision As Byte
    lfClipPrecision As Byte
    lfQuality As Byte
    lfPitchAndFamily As Byte
    lfFaceName(LF_FACESIZE - 1) As Byte
    'lfFaceName As String * 31
End Type

Public Type POINTAPI
        x As Long
        Y As Long
End Type

Type PAGESETUPDLG
        lStructSize As Long
        hwndOwner As Long
        hDevMode As Long
        hDevNames As Long
        Flags As Long
        ptPaperSize As POINTAPI
        rtMinMargin As RECT
        rtMargin As RECT
        hInstance As Long
        lCustData As Long
        lpfnPageSetupHook As Long
        lpfnPagePaintHook As Long
        lpPageSetupTemplateName As String
        hPageSetupTemplate As Long
End Type



'useful Win32 API declarations


Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
Declare Function CreateFontIndirect& Lib "gdi32" Alias "CreateFontIndirectA" (lpLogFont As LOGFONT)
Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long
Declare Function DeleteObject& Lib "gdi32" (ByVal hObject As Long)
Declare Function DocumentProperties Lib "winspool.drv" Alias "DocumentPropertiesA" (ByVal hwnd As Long, ByVal hPrinter As Long, ByVal pDeviceName As String, ByVal pDevModeOutput As Long, ByVal pDevModeInput As Long, ByVal fMode As Long) As Long
Declare Function GetClientRect& Lib "user32" (ByVal hwnd As Long, lpRect As RECT)
Declare Function GetDeviceCaps Lib "gdi32" (ByVal hdc As Long, ByVal nIndex As Long) As Long
Declare Function GetDIBits Lib "gdi32" (ByVal aHDC As Long, ByVal hBitmap As Long, ByVal nStartScan As Long, ByVal nNumScans As Long, lpBits As Any, lpBI As BITMAPINFO, ByVal wUsage As Long) As Long
Declare Function GetObjectAPI Lib "gdi32" Alias "GetObjectA" (ByVal hObject As Long, ByVal nCount As Long, lpObject As Any) As Long
Declare Function GetProfileString Lib "kernel32" Alias "GetProfileStringA" (ByVal lpAppName As String, ByVal lpKeyName As String, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long) As Long
Declare Function GlobalAlloc Lib "kernel32" (ByVal wFlags As Long, ByVal dwBytes As Long) As Long
Declare Function GlobalFree Lib "kernel32" (ByVal hMem As Long) As Long
Declare Function GlobalLock Lib "kernel32" (ByVal hMem As Long) As Long
Declare Function GlobalUnlock Lib "kernel32" (ByVal hMem As Long) As Long
Declare Function SetBkMode& Lib "gdi32" (ByVal hdc As Long, ByVal nBkMode As Long)
Declare Function SetDIBitsToDevice Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal Y As Long, ByVal dx As Long, ByVal dy As Long, ByVal SrcX As Long, ByVal SrcY As Long, ByVal Scan As Long, ByVal NumScans As Long, Bits As Any, BitsInfo As BITMAPINFO, ByVal wUsage As Long) As Long
Declare Function SelectObject& Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long)
Declare Function StartDoc Lib "gdi32" Alias "StartDocA" (ByVal hdc As Long, lpdi As DOCINFO) As Long
Declare Function StartPage Lib "gdi32" (ByVal hdc As Long) As Long
Declare Function StretchDIBits Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal Y As Long, ByVal dx As Long, ByVal dy As Long, ByVal SrcX As Long, ByVal SrcY As Long, ByVal wSrcWidth As Long, ByVal wSrcHeight As Long, lpBits As Any, lpBitsInfo As BITMAPINFO, ByVal wUsage As Long, ByVal dwRop As Long) As Long

' Added declarations for Raw Data Printing
' Declarations for access to WIN32 APIs
Declare Function ClosePrinter Lib "winspool.drv" (ByVal hPrinter As Long) As Long
Declare Function EndDocPrinter Lib "winspool.drv" (ByVal hPrinter As Long) As Long
Declare Function EndPagePrinter Lib "winspool.drv" (ByVal hPrinter As Long) As Long
Declare Function OpenPrinter Lib "winspool.drv" Alias "OpenPrinterA" (ByVal pPrinterName As String, phPrinter As Long, ByVal pDefault As Long) As Long
Declare Function StartDocPrinter Lib "winspool.drv" Alias "StartDocPrinterA" (ByVal hPrinter As Long, ByVal Level As Long, pDocInfo As DOCINFO_NEW) As Long
Declare Function StartPagePrinter Lib "winspool.drv" (ByVal hPrinter As Long) As Long
Declare Function WritePrinter Lib "winspool.drv" (ByVal hPrinter As Long, pBuf As Any, ByVal cdBuf As Long, pcWritten As Long) As Long
Declare Function ReadPrinter Lib "winspool.drv" (ByVal hPrinter As Long, ByRef pBuf As Any, ByVal cbBuf As Long, ByRef pNoBytesRead As Long) As Long

' Declarations for access to bypass printing functions in PADLL.DLL
Declare Function paPrintBypassOpenPrinter Lib "PADLL" (ByVal DocumentName As String) As Boolean
Declare Function paPrintBypassWritePrinter Lib "PADLL" (ByVal DataToWrite As String, ByVal BytesToWrite As Long) As Boolean
Declare Function paPrintBypassClosePrinter Lib "PADLL" () As Boolean
' The following function combines all 3 calls into 1. Document must be completely
' built before printing
Declare Function paPrintBypassPrintDocument Lib "PADLL" (ByVal DocumentName As String, ByVal DataToWrite As String, ByVal BytesToWrite As Long) As Boolean

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Pa status types
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Const PA_STAT_SHORT = 0
Public Const PA_STAT_NORMAL = 1
Public Const PA_STAT_EXTENDED = 2
Public Const PA_STAT_COUNT = 3
Public Const PA_STAT_TEMPERATURE = 4
Public Const PA_STAT_FORMLENGTH = 5
Public Const PA_STAT_COMPLETE = 6
Public Const PA_STAT_LAST = 7                ' 03/04/2002
Public Const PA_STAT_DOC_IN_PROGRESS = 8     ' 03/21/2002
Public Const PA_STATUS_MAX_LENGTH = 1024     ' 03/04/2002
Public Const PA_RETURN_MAX_LENGTH = 1024     ' 05/15/2007

Public Const FX_ETCH = 2
Public Const FX_EMBOSS = 3

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Const PA_ERR_OK = 0
Public Const PA_ERR = 49152
Public Const PA_ERR_BAD_PRINTER_NAME = (PA_ERR + 1)
Public Const PA_ERR_BAD_PORT_NAME = (PA_ERR + 2)
Public Const PA_ERR_SYSTEM = (PA_ERR + 3) ' user must use GetLastError()
Public Const PA_ERR_VAL_NOT_SET = (PA_ERR + 4)
Public Const PA_ERR_STRING_TOO_LONG = (PA_ERR + 5)
Public Const PA_ERR_PARAM1 = (PA_ERR + 6)
Public Const PA_ERR_PARAM2 = (PA_ERR + 7)
Public Const PA_ERR_PARAM3 = (PA_ERR + 8)
Public Const PA_ERR_PARAM4 = (PA_ERR + 9)
Public Const PA_ERR_NO_PRINTER_CHANGE = (PA_ERR + 10)
Public Const PA_ERR_ACCESS = (PA_ERR + 11)
Public Const PA_ERR_NO_PRINTERS = (PA_ERR + 12)
Public Const PA_ERR_REASSIGN = (PA_ERR + 13)
Public Const PA_ERR_BLOWN_POINTER = (PA_ERR + 14)
Public Const PA_ERR_OS_UNSUPPORTED = (PA_ERR + 15)
Public Const PA_ERR_PORT_BUSY = (PA_ERR + 16)
Public Const PA_ERR_BAD_STAT_GROUP = (PA_ERR + 17)
Public Const PA_ERR_BAD_STAT_FIELD = (PA_ERR + 18)
Public Const PA_ERR_BUFFER_TOO_SMALL = (PA_ERR + 19)
Public Const PA_ERR_INSUFFICIENT_MEM = (PA_ERR + 20)
Public Const PA_ERR_UNKNOWN_PRINTER = (PA_ERR + 21)
Public Const PA_ERR_PORT_HAS_SPOOLED_JOB = (PA_ERR + 22)
Public Const PA_ERR_SHEET_NOT_FOUND = (PA_ERR + 23)
Public Const PA_ERR_BIN_NOT_FOUND = (PA_ERR + 24)
'Error codes for language monitor
Public Const PA_ERR_PIPE_OPEN_BUSY = (PA_ERR + 25)
Public Const PA_ERR_PIPE_OPEN_FAILED = (PA_ERR + 26)
Public Const PA_ERR_PIPE_TIMEOUT = (PA_ERR + 27)
Public Const PA_ERR_PRINTER_NOT_RESPONDING = (PA_ERR + 28)
Public Const PA_ERR_STATUS_TIMEOUT = (PA_ERR + 29)

' Error codes related to firmware reprogramming
Public Const PA_ERR_PRINTER_NOT_READY = (PA_ERR + 31)
Public Const PA_ERR_BIN_FILE_NOT_FOUND = (PA_ERR + 32)
Public Const PA_ERR_BIN_FILE_BAD_EXTENTION = (PA_ERR + 33)
Public Const PA_ERR_CAN_NOT_GET_MODEL = (PA_ERR + 34)
Public Const PA_ERR_STATUS_READ_ERROR = (PA_ERR + 35)
Public Const PA_ERR_INCORRECT_BIN_FILE = (PA_ERR + 36)
Public Const PA_ERR_FLASH_NOT_ENTERED = (PA_ERR + 37)
Public Const PA_ERR_FLASH_BAD_BIN_FILE = (PA_ERR + 38)
Public Const PA_ERR_FLASH_REPROGRAM_FAILED = (PA_ERR + 39)
Public Const PA_ERR_MODEL_NOT_FOUND = (PA_ERR + 40)
Public Const PA_ERR_UNKNOWN_KEY = (PA_ERR + 41)


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Defines for legal paper bins GTX printer series
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Const PA_CUT_ALL = "Cut on all pages"
Public Const PA_CUT_2ND = "Cut every 2nd page"
Public Const PA_CUT_3RD = "Cut every 3rd page"
Public Const PA_CUT_4TH = "Cut every 4th page"
Public Const PA_CUT_5TH = "Cut every 5th page"
Public Const PA_CUT_LAST = "Cut on last page only"
Public Const PA_NO_CUT = "Disable cutting"


Public Const PA_ATX23 = 0
Public Const PA_ATX24 = 1
Public Const PA_ETX = 2
Public Const PA_ATX38 = 3
Public Const PA_GTX2002 = 4
Public Const PA_GTX2003 = 5
Public Const PA_GTX3004A_2 = 6
Public Const PA_GTX3004A_4 = 7


' Public variables

'  size of a device name string
Public Const CCHDEVICENAME = 32

'  size of a form name string
Public Const CCHFORMNAME = 32

Public Const BI_RGB = 0&

Global Const TWIPS = 1440




'typedef struct
'{
'    int     cx;
'    int     cy;
'    int     iPaperID;
'    int     iOrient;
'    HDC     hdc;
'    HFONT   hfCurr;
'    HFONT   hfPrev;
'    int     iSaveDC;
'    DOCINFO di;
'} DOC, *PDOC;
Type DOCINFO
    cbSize As Integer
    lpszDocName As Long
    lpszOutput As Long
    lpszDatatype As Long
    fwType As Long
End Type

Type DOCINFO_NEW
    pDocName As String
    pOutput As String
    pDataType As String
End Type


Type DOC
    cx As Integer
    cy As Integer
    iPaperID As Integer
    iOrient As Integer
    hdc As Long
    hfCurr As Long
    hfPrev As Long
    di As DOCINFO
End Type
    
Public Const SHEET_NAME_SIZE = 64
Type SHEET_NAMES
    achName(SHEET_NAME_SIZE) As Byte
End Type
    
Public Const BIN_NAME_SIZE = 24
Type BIN_NAMES
    achName(BIN_NAME_SIZE) As Byte
End Type

Private Type BITMAPINFOHEADERxxx '40 bytes
        biSize As Long
        biWidth As Long
        biHeight As Long
        biPlanes As Integer
        biBitCount As Integer
        biCompression As Long
        biSizeImage As Long
        biXPelsPerMeter As Long
        biYPelsPerMeter As Long
        biClrUsed As Long
        biClrImportant As Long
End Type

Type RGBQUAD
        rgbBlue As Byte
        rgbGreen As Byte
        rgbRed As Byte
        rgbReserved As Byte
End Type

Type BITMAPINFO
        bmiHeader As BITMAPINFOHEADER
        bmiColors(256) As RGBQUAD
End Type

Type BITMAP
        bmType As Long
        bmWidth As Long
        bmHeight As Long
        bmWidthBytes As Long
        bmPlanes As Integer
        bmBitsPixel As Integer
        bmBits As Long
End Type

Type COMMTIMEOUTS
    ReadIntervalTimeout As Long
    ReadTotalTimeoutMultiplier As Long
    ReadTotalTimeoutConstant As Long
    WriteTotalTimeoutMultiplier As Long
    WriteTotalTimeoutConstant As Long
End Type

' Structure the printer status
Type Status
    lStatBits   As Long
    lError      As Long
    lDocCount   As Long
    lTemp_C     As Long
    lTemp_F     As Long
    lFormLen    As Long
    '
    ch1Type     As String * 2
    ch2FormLen  As String * 16
    ch3Temp_C   As String * 4
    ch4DocCount As String * 9
    ch5Error As String * 4
    ch6StatBits As String * 8
    ch7Version  As String * 64
    '
    ver         As String * 16
    ver_date    As String * 16
End Type

' Structure for parsing the progress status
Type ProgressStatus
    progressState As Long             ' 0 = initial delay
                                      ' 1 = Sending Data
                                      ' 2 = Exit delay
                                      ' 3 = Complete
    progressMax As Long               ' Sending
    progressCurrent As Long           '
    progressPassFail As Byte          ' P or F
    progressNote As String * 1024     ' Ascii string indicating new version
                                      '  or reason for failure.
End Type

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'' Language Monitor functions
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Declare Function paLMSetPipeName Lib "PADLL" (ByVal PipeName As String) As Boolean
Declare Function paLMSetPipeTimeOut Lib "PADLL" (ByVal Timeout As Long) As Boolean
Declare Function paLMSetStatusTimeOut Lib "PADLL" (ByVal Timeout As Long) As Boolean
'LRESULT APIENTRY
'paLMGetStatus
'    (DWORD   dwType,                 // Status type 0 - 7
'     BYTE  * pResultBuffer,          // Pointer to result buffer
'     DWORD   dwResultBufferLength,   // Length of result buffer
'     DWORD * pdwResultBufferRead);   // Number of status bytes read
Declare Function paLMGetStatus Lib "PADLL" (ByVal dwType As Long, ByRef pResultBuffer As Byte, ByVal dwResultBufferLength As Long, ByRef pdwResultBufferRead As Long) As Long

'LRESULT APIENTRY
'paLMGetAddStatus
'    (LPSTR   pStatusReqString,       // Pointer to status request string
'     BYTE  * pResultBuffer,          // Pointer to result buffer
'     DWORD   dwResultBufferLength,   // Length of result buffer
'     DWORD * pdwResultBufferRead);   // Number of status bytes read
Declare Function paLMGetAddStatus Lib "PADLL" (ByVal pStatusReqString As String, ByRef pResultBuffer As Byte, ByVal dwResultBufferLength As Long, ByRef pdwResultBufferRead As Long) As Long

Declare Function paLMGetPrinterName Lib "PADLL" (ByRef pResultBuffer As Byte, ByVal dwResultBufferLength As Long, ByRef pdwResultBufferRead As Long) As Long
Declare Function paLMGetPortName Lib "PADLL" (ByRef pResultBuffer As Byte, ByVal dwResultBufferLength As Long, ByRef pdwResultBufferRead As Long) As Long
Declare Function paLMGetLMVersion Lib "PADLL" (ByRef pResultBuffer As Byte, ByVal dwResultBufferLength As Long, ByRef pdwResultBufferRead As Long) As Long

Declare Function paGetDLLVersion Lib "PADLL" (ByRef pResultBuffer As Byte, ByVal dwResultBufferLength As Long, ByRef pdwResultBufferRead As Long) As Boolean

' Function to set Language Monitor Key
Declare Function paLMSetRegistryKey Lib "PADLL" (ByVal RegistryKeyName As String, ByVal RegistryValue As Long, ByRef pResultBuffer As Byte, ByVal ReturnStringLength As Long, ByRef pdwResultBufferRead As Long) As Long
' Function to set Printer Key
Declare Function paSetPrinterKeyByName Lib "PADLL" (ByVal PrinterRegistryKeyName As String, ByVal PrinterRegistryValue As Long) As Long

Declare Function paPulseCashDrawerGPrinter Lib "PADLL" () As Boolean

Declare Function paLMGetDriverVersion Lib "PADLL" (ByVal PrinterName As String, ByRef pResultBuffer As Byte, ByVal dwResultBufferLength As Long, ByRef pdwResultBufferRead As Long) As Boolean

Declare Function paLMGetLastErrorNumber Lib "PADLL" (ByRef pResultBuffer As Byte, ByVal dwResultBufferLength As Long, ByRef pdwResultBufferRead As Long) As Long

Declare Function paLMResetPrinter Lib "PADLL" () As Long

Declare Function paLMWDSetup Lib "PADLL" (ByVal bEnableWd As Boolean, ByVal bResetOnCRC As Boolean, ByVal bytePrintingTimeout As Byte, ByVal byteHBTimeout As Byte) As Long

Declare Function paLMSetHeartBeat Lib "PADLL" (ByVal OnOff As Boolean) As Long
Declare Function paLMSetHeartBeatRate Lib "PADLL" (ByVal Rate As Long) As Long
Declare Function paLMSetSpoolerSaveMethod Lib "PADLL" (ByVal mode As Byte) As Long
Declare Function paLMRefresh Lib "PADLL" () As Long
Declare Function paLMIsPipe Lib "PADLL" () As Boolean
Declare Function paLMOpenPipe Lib "PADLL" (ByRef lpszPipeName, dwTimeOut As Long) As Long
Declare Function paLMClosePipe Lib "PADLL" () As Boolean

Declare Function paLMGetCRCError Lib "PADLL" (ByRef pbCRCError As Boolean) As Long
Declare Function paLMClearCRCError Lib "PADLL" () As Long
Declare Function paLMGetHeadLeverOpenStatus Lib "PADLL" (ByRef pbHeadLeverStatus As Boolean) As Long
Declare Function paLMGetOutOfPaperStatus Lib "PADLL" (ByRef pbOutOfPaperStatus As Boolean) As Long
Declare Function paLMGetLowPaperStatus Lib "PADLL" (ByRef pbLowPaperStatus As Boolean) As Long
Declare Function paLMGetManDeselectStatus Lib "PADLL" (ByRef pbManDeselectStatus As Boolean) As Long
Declare Function paLMGetJamStatus Lib "PADLL" (ByRef pbJamStatus As Boolean) As Long
Declare Function paLMGetTicketNotTakenStatus Lib "PADLL" (ByRef pbTicketNotTakenStatus As Boolean) As Long
Declare Function paLMGetPrinterOKStatus Lib "PADLL" (ByRef pbPrinterOKStatus As Boolean) As Long
Declare Function paLMGetPrinterOKStatus2 Lib "PADLL" (ByRef pbPrinterOKStatus As Boolean) As Long
Declare Function paLMGetPrintInProgress Lib "PADLL" (ByRef pbPrintInProgressStatus As Boolean) As Long

' Functions to reprogram printer flash
Declare Function paProgramFlash Lib "PADLL" (ByVal BinFileName As String, ByVal ProgramMode As Boolean, ByVal NewVersion As String, ByVal NewVersionLength As Long, ByVal Diag As Boolean) As Long
Declare Function paLMProgramFlash Lib "PADLL" (ByVal BinFileName As String, ByVal ProgramMode As Boolean, ByVal ReturnString As String, ByVal ReturnStringLength As Long) As Long
Declare Function paLMGetProgress Lib "PADLL" (ByVal ProgressType As String, ByRef pResultBuffer As Byte, ByVal dwResultBufferLength As Long, ByRef pdwResultBufferRead As Long) As Long

Declare Function paLMParseFlashProgress Lib "PADLL" (ByVal pProgressStatus As String, ByRef pProgStat As ProgressStatus) As Long
Declare Function paLMAbortDocument Lib "PADLL" () As Long

' RFID specific function
Declare Function paLMRFIDPrinter Lib "PADLL" (ByVal DataToWrite As String, ByVal NoBytesToWrite As Long, ByRef ResponseBytes As Byte, ByVal MaxResponseBytesLen As Long, ByRef NoBytesRead As Long, ByVal Timeout As Long) As Long

' Specific printer calls
Declare Function paLMPtrGetStatus Lib "PADLL" (ByVal pszPrinterName As String, ByVal dwType As Long, ByRef pResultBuffer As Byte, ByVal dwResultBufferLength As Long, ByRef pdwResultBufferRead As Long) As Long
Declare Function paLMPtrIsPipe Lib "PADLL" (ByVal pszPrinterName As String) As Boolean
Declare Function paLMPtrRFIDPrinter Lib "PADLL" (ByVal pszPrinterName As String, ByVal DataToWrite As String, ByVal NoBytesToWrite As Long, ByRef ResponseBytes As Byte, ByVal MaxResponseBytesLen As Long, ByRef NoBytesRead As Long, ByVal Timeout As Long) As Long

' Bit assignements for MS status byte
Public Const PA_PRINTER_NOT_READY = &H80
Public Const PA_PRINTER_SYSTEM_ERROR = &H40
Public Const PA_PRINTER_MAN_DESELECT = &H20
Public Const PA_PRINTER_OUTPUT_JAM = &H10

Public Const PA_PRINTER_PAPER_ERROR = &H8
Public Const PA_PRINTER_CUTTER_JAM = &H4
Public Const PA_PRINTER_HEAD_LEVER_UP = &H2
Public Const PA_PRINTER_OUT_OF_PAPER = &H1

' Bit assignements for LS status byte
Public Const PA_PRINTER_DOC_IN_PROGRESS = &H80
Public Const PA_PRINTER_DATA_ERROR = &H40
Public Const PA_PRINTER_BUSY = &H20
Public Const PA_PRINTER_PH_TEMPERATURE_LIMIT = &H10

Public Const PA_PRINTER_TICKET_NOT_TAKEN = &H8
Public Const PA_PRINTER_APW = &H4
Public Const PA_PRINTER_TICKET_DISPOSED_TOGGLE = &H2
Public Const PA_PRINTER_LOW_PAPER = &H1




''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

' for VB fans
Declare Function paEnumBins Lib "PADLL" (ByRef pBinNames As Byte, ByRef pBinNumbers As Integer, ByRef plNumberOfBins As Long) As Long
Declare Function paEnumSheetSizes Lib "PADLL" (ByRef pSheetNames As Byte, ByRef pSheetID As Integer, ByRef plSheetsFound As Long) As Long
Declare Function paEnumPrinters Lib "PADLL" (ByRef pInfoStructures As Byte, ByVal Size As Long, ByVal Level As Long, ByRef Need As Long, ByRef pdwFound As Long) As Long
Declare Function paAcquirePort Lib "PADLL" (ByVal pszPrinter As String) As Long
Declare Function paReleasePort Lib "PADLL" () As Long
Declare Function paGetStatus Lib "PADLL" (ByVal lType As Long, ByRef pBuffer As Byte, ByVal lBuffLen As Long, ByRefplRead As Long) As Long
Declare Function paGetAddStatus Lib "PADLL" (ByRef pStatusReqString As Byte, ByRef pBuffer As Byte, ByVal lBuffLen As Long, ByRefplRead As Long) As Long
Declare Function paParseStatus Lib "PADLL" (ByVal pStatus As String, ByVal lLen As Long, ByRefpStat As Status) As Long
Declare Function paSetSheetSize Lib "PADLL" (ByRef Width As Single, ByRefLength As Single) As Long
Declare Function paSetBinByBinName Lib "PADLL" (ByVal BinName As String) As Long
Declare Function paGetOSVersion Lib "PADLL" (OsVer As OSVERSIONINFO, ByVal pptr As String) As Long
Declare Function paIsNT Lib "PADLL" () As Integer
Declare Function paGetDefaultPrinter Lib "PADLL" (psd As PAGESETUPDLG) As Long
Declare Function paSetDefaulPrinter Lib "PADLL" (psd As PAGESETUPDLG) As Long
Declare Function paSetVB Lib "PADLL" (ByVal yesno As Integer) As Long
Declare Function paGetHDC Lib "PADLL" (psd As PAGESETUPDLG, pHDC As Long) As Long
Declare Function paGetPrinterNameAndPort Lib "PADLL" (psd As PAGESETUPDLG, ByVal pName As String, cName As Long, ByVal pPort As String, cPort As Long, ByVal pDriver As String, cDriver As Long) As Long
Declare Function paSetNewPrinter Lib "PADLL" (ByVal pszNewPrinter As String) As Boolean
Declare Function paSetNTPortAscii Lib "PADLL" (ByVal pszNewPort As String) As Boolean
Declare Function paSetOrientation Lib "PADLL" (ByVal orientation As Long) As Long

Declare Function paGetAddressForObject Lib "PADLL" (ByRef Stuff As Byte) As Long
Declare Function paGetStringFromLPSTR Lib "PADLL" (ByVal ptr As Long) As String
Declare Sub paCopyData Lib "PADLL" (Source As Any, dest As Any, ByVal count As Long)

Declare Function paFindMaxFont& Lib "PADLL" (ByVal hdc&, ByVal x&, ByVal Y&, ByVal s$, lf As LOGFONT)
Declare Function paFontFX& Lib "PADLL" (ByVal hdc As Long, rcl As RECT, ByVal s$, ByVal iFx As Integer, ByVal cText&, ByVal cShadow&)
Declare Function paGetPrinterCaps& Lib "PADLL" (ByVal pszPrinter$, dwNeeded&, pResult As Any)
Declare Function paMakeDocDC& Lib "PADLL" (ByVal iOrient As Integer, ByVal fSize As Single, ByVal bin As Integer, pdoc As DOC, psd As PAGESETUPDLG, hdc&)
Declare Function paSetBin& Lib "PADLL" (psd As PAGESETUPDLG)


Sub CenterForm(frm As Form)
    
    frm.left = (Screen.Width - frm.Width) / 2   ' Center form horizontally.
    frm.top = (Screen.Height - frm.Height) / 2  ' Center form vertically.

End Sub

Public Function ClipCString$(Cstring$)
Dim x As Integer

    x = InStr(Cstring, Chr(0))  'find the trailing NULL
    If x Then
        ClipCString = left$(Cstring, x - 1) ' and return everything BEFORE it
    Else
        ClipCString = Cstring
    End If
     
End Function



Public Sub LogDefaultPrinter()

    Dim lRC&
    Dim Response
    Dim Caption As String
    
    psdCurrent.Flags = PSD_SHOWHELP
    usPrinterDriver = ""
    lRC = paGetDefaultPrinter(psdCurrent)
    If lRC <> PA_ERR_OK Then
        'Caption = Caption & " No default printer found!"
        Response = MsgBox("No printer appears to be installed!", vbCritical, "Error!")
        Exit Sub
    Else
        lRC = paGetPrinterNameAndPort(psdCurrent, usPrinterName, cName, _
            usPrinterPort, cPort, usPrinterDriver, cDriver)
        ' The returned usPrinterName haves a terminator that prevents
        ' it from being concatentated hence the use of the left$
        Caption = Caption & " " & left$(usPrinterName, cName) & ", on port " & left$(usPrinterPort, cPort)
        'MsgBox (Caption)
    End If

    
End Sub

Public Function PrinterModelName$(Optional Index As Integer)
Dim ModelNames As Variant

    ModelNames = Array("ATX23", "ATX24", "ETX", _
        "ATX38", "GTX2002", "GTX2003", "GTX3004 2", "GTX3004 4")
    
    PrinterModelName$ = ModelNames(gPrinterType)
    
End Function
